Databases - Create

Creates a database

PUT https://management.azure.com/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Cache/redisEnterprise/{clusterName}/databases/{databaseName}?api-version=2026-09-01

URI Parameters

Name In Required Type Description
clusterName
path True

string

pattern: ^(?=.{1,60}$)[A-Za-z0-9]+(-[A-Za-z0-9]+)*$

The name of the Redis Enterprise cluster. Name must be 1-60 characters long. Allowed characters(A-Z, a-z, 0-9) and hyphen(-). There can be no leading nor trailing nor consecutive hyphens

databaseName
path True

string

pattern: ^(?=.{1,60}$)[A-Za-z0-9]+(-[A-Za-z0-9]+)*$

The name of the Redis Enterprise database.

resourceGroupName
path True

string

minLength: 1
maxLength: 90

The name of the resource group. The name is case insensitive.

subscriptionId
path True

string (uuid)

The ID of the target subscription. The value must be an UUID.

api-version
query True

string

minLength: 1

The API version to use for this operation.

Request Body

Name Type Description
properties.accessKeysAuthentication

AccessKeysAuthentication

This property can be Enabled/Disabled to allow or deny access with the current access keys. Can be updated even after database is created. Default is Disabled.

properties.clientProtocol

Protocol

Specifies whether redis clients can connect using TLS-encrypted or plaintext redis protocols. Default is TLS-encrypted.

properties.clusteringPolicy

ClusteringPolicy

Clustering policy - default is OSSCluster. This property can be updated only if the current value is NoCluster. If the value is OSSCluster or EnterpriseCluster, it cannot be updated without deleting the database.

properties.deferUpgrade

DeferUpgradeSetting

Option to defer upgrade when newest version is released - default is NotDeferred. Learn more: https://aka.ms/redisversionupgrade

properties.evictionPolicy

EvictionPolicy

Redis eviction policy - default is VolatileLRU

properties.geoReplication

DatabasePropertiesGeoReplication

Optional set of properties to configure geo replication for this database.

properties.modules

Module[]

Optional set of redis modules to enable in this database - modules can only be added at creation time.

properties.notifyKeyspaceEvents

string

Specifies which keyspace events should trigger notifications. Default is an empty string, meaning this feature is disabled. When enabled, at least 'K' (keyspace events) or 'E' (keyevent events) must be present. For example, 'AKE' enables all standard events. See https://redis.io/docs/latest/develop/use/keyspace-notifications/ for the complete list of event types.

properties.persistence

Persistence

Persistence settings

properties.port

integer (int32)

TCP port of the database endpoint. Specified at create time. Defaults to an available port.

Responses

Name Type Description
200 OK

Database

Resource 'Database' update operation succeeded

201 Created

Database

Resource 'Database' create operation succeeded

Headers

  • Azure-AsyncOperation: string
  • Retry-After: integer
Other Status Codes

ErrorResponse

An unexpected error response.

Security

azure_auth

Azure Active Directory OAuth2 Flow.

Type: oauth2
Flow: implicit
Authorization URL: https://login.microsoftonline.com/common/oauth2/authorize

Scopes

Name Description
user_impersonation impersonate your user account

Examples

RedisEnterpriseDatabasesCreate
RedisEnterpriseDatabasesCreate No Cluster Cache
RedisEnterpriseDatabasesCreate With Active Geo Replication

RedisEnterpriseDatabasesCreate

Sample request

PUT https://management.azure.com/subscriptions/e7b5a9d2-6b6a-4d2f-9143-20d9a10f5b8f/resourceGroups/rg1/providers/Microsoft.Cache/redisEnterprise/cache1/databases/default?api-version=2026-09-01

{
  "properties": {
    "accessKeysAuthentication": "Enabled",
    "clientProtocol": "Encrypted",
    "clusteringPolicy": "EnterpriseCluster",
    "deferUpgrade": "NotDeferred",
    "evictionPolicy": "AllKeysLRU",
    "notifyKeyspaceEvents": "KEA",
    "modules": [
      {
        "name": "RedisBloom",
        "args": "ERROR_RATE 0.00 INITIAL_SIZE 400"
      },
      {
        "name": "RedisTimeSeries",
        "args": "RETENTION_POLICY 20"
      },
      {
        "name": "RediSearch"
      }
    ],
    "persistence": {
      "aofEnabled": true,
      "aofFrequency": "1s"
    },
    "port": 10000
  }
}

Sample response

{
  "name": "cache1/default",
  "type": "Microsoft.Cache/redisEnterprise/databases",
  "id": "/subscriptions/e7b5a9d2-6b6a-4d2f-9143-20d9a10f5b8f/resourceGroups/rg1/providers/Microsoft.Cache/redisEnterprise/cache1/databases/default",
  "properties": {
    "accessKeysAuthentication": "Enabled",
    "clientProtocol": "Encrypted",
    "clusteringPolicy": "EnterpriseCluster",
    "deferUpgrade": "NotDeferred",
    "evictionPolicy": "AllKeysLRU",
    "notifyKeyspaceEvents": "KEA",
    "modules": [
      {
        "name": "RedisBloom",
        "args": "ERROR_RATE 0.00 INITIAL_SIZE 400",
        "version": "1.0.0"
      },
      {
        "name": "RedisTimeSeries",
        "args": "RETENTION_POLICY 20",
        "version": "1.0.0"
      },
      {
        "name": "RediSearch",
        "args": "",
        "version": "1.0.0"
      }
    ],
    "persistence": {
      "aofEnabled": true,
      "aofFrequency": "1s"
    },
    "port": 10000,
    "provisioningState": "Updating",
    "redisVersion": "6.0",
    "resourceState": "Updating"
  }
}
{
  "name": "cache1/db1",
  "type": "Microsoft.Cache/redisEnterprise/databases",
  "id": "/subscriptions/e7b5a9d2-6b6a-4d2f-9143-20d9a10f5b8f/resourceGroups/rg1/providers/Microsoft.Cache/redisEnterprise/cache1/databases/db1",
  "properties": {
    "accessKeysAuthentication": "Enabled",
    "clientProtocol": "Encrypted",
    "clusteringPolicy": "EnterpriseCluster",
    "evictionPolicy": "AllKeysLRU",
    "notifyKeyspaceEvents": "KEA",
    "modules": [
      {
        "name": "RedisBloom",
        "args": "ERROR_RATE 0.00 INITIAL_SIZE 400",
        "version": "1.0.0"
      },
      {
        "name": "RedisTimeSeries",
        "args": "RETENTION_POLICY 20",
        "version": "1.0.0"
      },
      {
        "name": "RediSearch",
        "args": "",
        "version": "1.0.0"
      }
    ],
    "persistence": {
      "aofEnabled": true,
      "aofFrequency": "1s"
    },
    "port": 10000,
    "provisioningState": "Creating",
    "resourceState": "Creating"
  }
}

RedisEnterpriseDatabasesCreate No Cluster Cache

Sample request

PUT https://management.azure.com/subscriptions/e7b5a9d2-6b6a-4d2f-9143-20d9a10f5b8f/resourceGroups/rg1/providers/Microsoft.Cache/redisEnterprise/cache1/databases/default?api-version=2026-09-01

{
  "properties": {
    "clientProtocol": "Encrypted",
    "clusteringPolicy": "NoCluster",
    "evictionPolicy": "NoEviction",
    "notifyKeyspaceEvents": "",
    "port": 10000
  }
}

Sample response

{
  "name": "cache1/default",
  "type": "Microsoft.Cache/redisEnterprise/databases",
  "id": "/subscriptions/e7b5a9d2-6b6a-4d2f-9143-20d9a10f5b8f/resourceGroups/rg1/providers/Microsoft.Cache/redisEnterprise/cache1/databases/default",
  "properties": {
    "accessKeysAuthentication": "Enabled",
    "clientProtocol": "Encrypted",
    "clusteringPolicy": "NoCluster",
    "deferUpgrade": "NotDeferred",
    "evictionPolicy": "NoEviction",
    "notifyKeyspaceEvents": "",
    "port": 10000,
    "provisioningState": "Updating",
    "redisVersion": "7.2",
    "resourceState": "Updating"
  }
}
{
  "name": "cache1/default",
  "type": "Microsoft.Cache/redisEnterprise/databases",
  "id": "/subscriptions/e7b5a9d2-6b6a-4d2f-9143-20d9a10f5b8f/resourceGroups/rg1/providers/Microsoft.Cache/redisEnterprise/cache1/databases/default",
  "properties": {
    "accessKeysAuthentication": "Enabled",
    "clientProtocol": "Encrypted",
    "clusteringPolicy": "NoCluster",
    "deferUpgrade": "NotDeferred",
    "evictionPolicy": "NoEviction",
    "notifyKeyspaceEvents": "",
    "port": 10000,
    "provisioningState": "Creating",
    "redisVersion": "7.2",
    "resourceState": "Creating"
  }
}

RedisEnterpriseDatabasesCreate With Active Geo Replication

Sample request

PUT https://management.azure.com/subscriptions/e7b5a9d2-6b6a-4d2f-9143-20d9a10f5b8f/resourceGroups/rg1/providers/Microsoft.Cache/redisEnterprise/cache1/databases/default?api-version=2026-09-01

{
  "properties": {
    "accessKeysAuthentication": "Enabled",
    "clientProtocol": "Encrypted",
    "clusteringPolicy": "EnterpriseCluster",
    "evictionPolicy": "NoEviction",
    "geoReplication": {
      "groupNickname": "groupName",
      "linkedDatabases": [
        {
          "id": "/subscriptions/e7b5a9d2-6b6a-4d2f-9143-20d9a10f5b8f/resourceGroups/rg1/providers/Microsoft.Cache/redisEnterprise/cache1/databases/default"
        },
        {
          "id": "/subscriptions/e7b5a9d2-6b6a-4d2f-9143-20d9a10f5b8e/resourceGroups/rg2/providers/Microsoft.Cache/redisEnterprise/cache2/databases/default"
        }
      ]
    },
    "notifyKeyspaceEvents": "KEA",
    "port": 10000
  }
}

Sample response

{
  "name": "cache1/default",
  "type": "Microsoft.Cache/redisEnterprise/databases",
  "id": "/subscriptions/e7b5a9d2-6b6a-4d2f-9143-20d9a10f5b8f/resourceGroups/rg1/providers/Microsoft.Cache/redisEnterprise/cache1/databases/default",
  "properties": {
    "accessKeysAuthentication": "Enabled",
    "clientProtocol": "Encrypted",
    "clusteringPolicy": "EnterpriseCluster",
    "deferUpgrade": "NotDeferred",
    "evictionPolicy": "NoEviction",
    "geoReplication": {
      "groupNickname": "groupName",
      "linkedDatabases": [
        {
          "id": "/subscriptions/e7b5a9d2-6b6a-4d2f-9143-20d9a10f5b8e/resourceGroups/rg1/providers/Microsoft.Cache/redisEnterprise/cache1/databases/default",
          "state": "Linking"
        },
        {
          "id": "/subscriptions/e7b5a9d2-6b6a-4d2f-9143-20d9a10f5b8f2/resourceGroups/rg2/providers/Microsoft.Cache/redisEnterprise/cache2/databases/default",
          "state": "Linking"
        }
      ]
    },
    "notifyKeyspaceEvents": "KEA",
    "port": 10000,
    "provisioningState": "Updating",
    "redisVersion": "6.0",
    "resourceState": "Updating"
  }
}
{
  "name": "cache1/db1",
  "type": "Microsoft.Cache/redisEnterprise/databases",
  "id": "/subscriptions/e7b5a9d2-6b6a-4d2f-9143-20d9a10f5b8f/resourceGroups/rg1/providers/Microsoft.Cache/redisEnterprise/cache1/databases/db1",
  "properties": {
    "accessKeysAuthentication": "Enabled",
    "clientProtocol": "Plaintext",
    "clusteringPolicy": "EnterpriseCluster",
    "deferUpgrade": "NotDeferred",
    "evictionPolicy": "NoEviction",
    "geoReplication": {
      "groupNickname": "groupName",
      "linkedDatabases": [
        {
          "id": "/subscriptions/e7b5a9d2-6b6a-4d2f-9143-20d9a10f5b8e/resourceGroups/rg1/providers/Microsoft.Cache/redisEnterprise/cache1/databases/default",
          "state": "Linking"
        },
        {
          "id": "/subscriptions/e7b5a9d2-6b6a-4d2f-9143-20d9a10f5b8f2/resourceGroups/rg2/providers/Microsoft.Cache/redisEnterprise/cache2/databases/default",
          "state": "Linking"
        }
      ]
    },
    "notifyKeyspaceEvents": "KEA",
    "port": 10000,
    "provisioningState": "Creating",
    "redisVersion": "6.0",
    "resourceState": "Creating"
  }
}

Definitions

Name Description
AccessKeysAuthentication

This property can be Enabled/Disabled to allow or deny access with the current access keys. Can be updated even after database is created.

AofFrequency

Sets the frequency at which data is written to disk. Defaults to '1s', meaning 'every second'. Note that the 'always' setting is deprecated, because of its performance impact.

ClusteringPolicy

Clustering policy - default is OSSCluster. This property can be updated only if the current value is NoCluster. If the value is OSSCluster or EnterpriseCluster, it cannot be updated without deleting the database.

createdByType

The type of identity that created the resource.

Database

Describes a database on the Redis Enterprise cluster

DatabasePropertiesGeoReplication

Optional set of properties to configure geo replication for this database.

DeferUpgradeSetting

Option to defer upgrade when newest version is released - default is NotDeferred. Learn more: https://aka.ms/redisversionupgrade

ErrorAdditionalInfo

The resource management error additional info.

ErrorDetail

The error detail.

ErrorResponse

Error response

EvictionPolicy

Redis eviction policy - default is VolatileLRU

LinkedDatabase

Specifies details of a linked database resource.

LinkState

State of the link between the database resources.

Module

Specifies configuration of a redis module

Persistence

Persistence-related configuration for the Redis Enterprise database

Protocol

Specifies whether redis clients can connect using TLS-encrypted or plaintext redis protocols. Default is TLS-encrypted.

ProvisioningState

Current provisioning status

RdbFrequency

Sets the frequency at which a snapshot of the database is created.

ResourceState

Current resource status

systemData

Metadata pertaining to creation and last modification of the resource.

AccessKeysAuthentication

This property can be Enabled/Disabled to allow or deny access with the current access keys. Can be updated even after database is created.

Value Description
Disabled

Disabled

Enabled

Enabled

AofFrequency

Sets the frequency at which data is written to disk. Defaults to '1s', meaning 'every second'. Note that the 'always' setting is deprecated, because of its performance impact.

Value Description
1s

1s

always

always

ClusteringPolicy

Clustering policy - default is OSSCluster. This property can be updated only if the current value is NoCluster. If the value is OSSCluster or EnterpriseCluster, it cannot be updated without deleting the database.

Value Description
EnterpriseCluster

Enterprise clustering policy uses only the classic redis protocol, which does not support redis cluster commands.

OSSCluster

OSS clustering policy follows the redis cluster specification, and requires all clients to support redis clustering.

NoCluster

The NoCluster policy is used for non-clustered Redis instances that do not require clustering features.

createdByType

The type of identity that created the resource.

Value Description
User
Application
ManagedIdentity
Key

Database

Describes a database on the Redis Enterprise cluster

Name Type Default value Description
id

string (arm-id)

Fully qualified resource ID for the resource. E.g. "/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/{resourceProviderNamespace}/{resourceType}/{resourceName}"

name

string

The name of the resource

properties.accessKeysAuthentication

AccessKeysAuthentication

Disabled

This property can be Enabled/Disabled to allow or deny access with the current access keys. Can be updated even after database is created. Default is Disabled.

properties.clientProtocol

Protocol

Specifies whether redis clients can connect using TLS-encrypted or plaintext redis protocols. Default is TLS-encrypted.

properties.clusteringPolicy

ClusteringPolicy

Clustering policy - default is OSSCluster. This property can be updated only if the current value is NoCluster. If the value is OSSCluster or EnterpriseCluster, it cannot be updated without deleting the database.

properties.deferUpgrade

DeferUpgradeSetting

Option to defer upgrade when newest version is released - default is NotDeferred. Learn more: https://aka.ms/redisversionupgrade

properties.evictionPolicy

EvictionPolicy

Redis eviction policy - default is VolatileLRU

properties.geoReplication

DatabasePropertiesGeoReplication

Optional set of properties to configure geo replication for this database.

properties.modules

Module[]

Optional set of redis modules to enable in this database - modules can only be added at creation time.

properties.notifyKeyspaceEvents

string

Specifies which keyspace events should trigger notifications. Default is an empty string, meaning this feature is disabled. When enabled, at least 'K' (keyspace events) or 'E' (keyevent events) must be present. For example, 'AKE' enables all standard events. See https://redis.io/docs/latest/develop/use/keyspace-notifications/ for the complete list of event types.

properties.persistence

Persistence

Persistence settings

properties.port

integer (int32)

TCP port of the database endpoint. Specified at create time. Defaults to an available port.

properties.provisioningState

ProvisioningState

Current provisioning status of the database

properties.redisVersion

string

Version of Redis the database is running on, e.g. '6.0'

properties.resourceState

ResourceState

Current resource status of the database

systemData

systemData

Azure Resource Manager metadata containing createdBy and modifiedBy information.

type

string

The type of the resource. E.g. "Microsoft.Compute/virtualMachines" or "Microsoft.Storage/storageAccounts"

DatabasePropertiesGeoReplication

Optional set of properties to configure geo replication for this database.

Name Type Description
groupNickname

string

Name for the group of linked database resources

linkedDatabases

LinkedDatabase[]

List of database resources to link with this database

DeferUpgradeSetting

Option to defer upgrade when newest version is released - default is NotDeferred. Learn more: https://aka.ms/redisversionupgrade

Value Description
Deferred

Deferred

NotDeferred

NotDeferred

ErrorAdditionalInfo

The resource management error additional info.

Name Type Description
info

object

The additional info.

type

string

The additional info type.

ErrorDetail

The error detail.

Name Type Description
additionalInfo

ErrorAdditionalInfo[]

The error additional info.

code

string

The error code.

details

ErrorDetail[]

The error details.

message

string

The error message.

target

string

The error target.

ErrorResponse

Error response

Name Type Description
error

ErrorDetail

The error object.

EvictionPolicy

Redis eviction policy - default is VolatileLRU

Value Description
AllKeysLFU

AllKeysLFU

AllKeysLRU

AllKeysLRU

AllKeysRandom

AllKeysRandom

VolatileLRU

VolatileLRU

VolatileLFU

VolatileLFU

VolatileTTL

VolatileTTL

VolatileRandom

VolatileRandom

NoEviction

NoEviction

LinkedDatabase

Specifies details of a linked database resource.

Name Type Description
id

string (arm-id)

Resource ID of a database resource to link with this database.

state

LinkState

State of the link between the database resources.

LinkState

State of the link between the database resources.

Value Description
Linked

Linked

Linking

Linking

Unlinking

Unlinking

LinkFailed

LinkFailed

UnlinkFailed

UnlinkFailed

Module

Specifies configuration of a redis module

Name Type Description
args

string

Configuration options for the module, e.g. 'ERROR_RATE 0.01 INITIAL_SIZE 400'.

name

string

The name of the module, e.g. 'RedisBloom', 'RediSearch', 'RedisTimeSeries'

version

string

The version of the module, e.g. '1.0'.

Persistence

Persistence-related configuration for the Redis Enterprise database

Name Type Description
aofEnabled

boolean

Sets whether AOF is enabled. Note that at most one of AOF or RDB persistence may be enabled.

aofFrequency

AofFrequency

Sets the frequency at which data is written to disk. Defaults to '1s', meaning 'every second'. Note that the 'always' setting is deprecated, because of its performance impact.

rdbEnabled

boolean

Sets whether RDB is enabled. Note that at most one of AOF or RDB persistence may be enabled.

rdbFrequency

RdbFrequency

Sets the frequency at which a snapshot of the database is created.

Protocol

Specifies whether redis clients can connect using TLS-encrypted or plaintext redis protocols. Default is TLS-encrypted.

Value Description
Encrypted

Encrypted

Plaintext

Plaintext

ProvisioningState

Current provisioning status

Value Description
Succeeded

Succeeded

Failed

Failed

Canceled

Canceled

Creating

Creating

Updating

Updating

Deleting

Deleting

RdbFrequency

Sets the frequency at which a snapshot of the database is created.

Value Description
1h

1h

6h

6h

12h

12h

ResourceState

Current resource status

Value Description
Running

Running

Creating

Creating

CreateFailed

CreateFailed

Updating

Updating

UpdateFailed

UpdateFailed

Deleting

Deleting

DeleteFailed

DeleteFailed

Enabling

Enabling

EnableFailed

EnableFailed

Disabling

Disabling

DisableFailed

DisableFailed

Disabled

Disabled

Scaling

Scaling

ScalingFailed

ScalingFailed

Moving

Moving

systemData

Metadata pertaining to creation and last modification of the resource.

Name Type Description
createdAt

string (date-time)

The timestamp of resource creation (UTC).

createdBy

string

The identity that created the resource.

createdByType

createdByType

The type of identity that created the resource.

lastModifiedAt

string (date-time)

The timestamp of resource last modification (UTC)

lastModifiedBy

string

The identity that last modified the resource.

lastModifiedByType

createdByType

The type of identity that last modified the resource.